import { EventEmitter } from '@angular/core';
import { Object3D } from 'three';
import { ThreeColor, ThreeEuler, ThreeEvent, ThreeQuaternion, ThreeVector3, UnknownRecord } from '../typings';
import { Controller } from './controller.abstract';
import * as i0 from "@angular/core";
export declare class Object3dControllerDirective extends Controller {
    name?: string;
    position?: ThreeVector3;
    rotation?: ThreeEuler;
    quaternion?: ThreeQuaternion;
    scale?: ThreeVector3;
    color?: ThreeColor;
    userData?: UnknownRecord;
    dispose?: () => void;
    castShadow: boolean;
    receiveShadow: boolean;
    visible: boolean;
    matrixAutoUpdate: boolean;
    appendMode: 'immediate' | 'root';
    appendTo?: Object3D;
    click: EventEmitter<ThreeEvent<MouseEvent>>;
    contextmenu: EventEmitter<ThreeEvent<MouseEvent>>;
    dblclick: EventEmitter<ThreeEvent<MouseEvent>>;
    pointerup: EventEmitter<ThreeEvent<PointerEvent>>;
    pointerdown: EventEmitter<ThreeEvent<PointerEvent>>;
    pointerover: EventEmitter<ThreeEvent<PointerEvent>>;
    pointerout: EventEmitter<ThreeEvent<PointerEvent>>;
    pointerenter: EventEmitter<ThreeEvent<PointerEvent>>;
    pointerleave: EventEmitter<ThreeEvent<PointerEvent>>;
    pointermove: EventEmitter<ThreeEvent<PointerEvent>>;
    pointermissed: EventEmitter<ThreeEvent<PointerEvent>>;
    pointercancel: EventEmitter<ThreeEvent<PointerEvent>>;
    wheel: EventEmitter<ThreeEvent<WheelEvent>>;
    static ɵfac: i0.ɵɵFactoryDeclaration<Object3dControllerDirective, never>;
    static ɵdir: i0.ɵɵDirectiveDeclaration<Object3dControllerDirective, "    ngt-primitive,    ngt-mesh,    ngt-instanced-mesh,    ngt-skinned-mesh,    ngt-bone,    ngt-group,    ngt-lod,    ngt-scene,    ngt-points,    ngt-cube-camera,    ngt-contact-shadows,    ngt-light-probe,    ngt-ambient-light,    ngt-ambient-light-probe,    ngt-hemisphere-light,    ngt-hemisphere-light-probe,    ngt-directional-light,    ngt-point-light,    ngt-spot-light,    ngt-rect-area-light,    ngt-arrow-helper,    ngt-axes-helper,    ngt-box-helper,    ngt-box3-helper,    ngt-grid-helper,    ngt-camera-helper,    ngt-directional-light-helper,    ngt-hemisphere-light-helper,    ngt-plane-helper,    ngt-point-light-helper,    ngt-polar-grid-helper,    ngt-skeleton-helper,    ngt-spot-light-helper,    ngt-line,    ngt-line-loop,    ngt-line-segments,    ngt-sprite,    ngt-camera,    ngt-perspective-camera,    ngt-orthographic-camera,    ngt-array-camera,    ngt-stereo-camera  ", ["ngtObject3dController"], { "name": "name"; "position": "position"; "rotation": "rotation"; "quaternion": "quaternion"; "scale": "scale"; "color": "color"; "userData": "userData"; "dispose": "dispose"; "castShadow": "castShadow"; "receiveShadow": "receiveShadow"; "visible": "visible"; "matrixAutoUpdate": "matrixAutoUpdate"; "appendMode": "appendMode"; "appendTo": "appendTo"; }, { "click": "click"; "contextmenu": "contextmenu"; "dblclick": "dblclick"; "pointerup": "pointerup"; "pointerdown": "pointerdown"; "pointerover": "pointerover"; "pointerout": "pointerout"; "pointerenter": "pointerenter"; "pointerleave": "pointerleave"; "pointermove": "pointermove"; "pointermissed": "pointermissed"; "pointercancel": "pointercancel"; "wheel": "wheel"; }, never>;
}
